<?php

class ControllerExtensionPaymentEasypay extends Controller
{
    private $error = array();

    public function index()
    {
        $this->load->language('extension/payment/easypay');
        $this->document->setTitle($this->language->get('heading_title'));
        $this->load->model('setting/setting');


        if ($this->request->server['REQUEST_METHOD'] == 'POST' && $this->validate()) {
            $this->model_setting_setting->editSetting('payment_easypay', $this->request->post);
            $this->session->data['success'] = $this->language->get('text_success');
            $this->response->redirect($this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true));
        }

        $data['text_enabled'] = $this->language->get('text_enabled');
        $data['text_disabled'] = $this->language->get('text_disabled');
        $data['text_edit'] = $this->language->get('text_edit');
        $data['entry_merchant'] = $this->language->get('entry_merchant');
        $data['entry_webkey'] = $this->language->get('entry_webkey');
        $data['entry_expires'] = $this->language->get('entry_expires');
        $data['entry_debug'] = $this->language->get('entry_debug');
        $data['entry_status'] = $this->language->get('entry_status');
        $data['entry_order_status_id'] = $this->language->get('entry_order_status_id');
        $data['entry_processing_status_id'] = $this->language->get('entry_processing_status_id');
        $data['entry_canceled_status_id'] = $this->language->get('entry_canceled_status_id');
        $data['button_save'] = $this->language->get('button_save');
        $data['button_cancel'] = $this->language->get('button_cancel');
        $data['error_warning'] = $this->language->get('error_warning');
        $data['merchant_comment'] = $this->language->get('merchant_comment');
        $data['webkey_comment'] = $this->language->get('webkey_comment');
        $data['expires_comment'] = $this->language->get('expires_comment');
        $data['debug_comment'] = $this->language->get('debug_comment');
        $data['sort_order_label'] = $this->language->get('sort_order_label');
        $data['action'] = $this->url->link('extension/payment/easypay', 'user_token=' . $this->session->data['user_token'], true);
        $data['cancel'] = $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true);

        if (isset($this->error['merchant'])) {
            $data['error_merchant'] = $this->error['merchant'];
        } else {
            $data['error_merchant'] = '';
        }

        if (isset($this->error['webkey'])) {
            $data['error_webkey'] = $this->error['webkey'];
        } else {
            $data['error_webkey'] = '';
        }

        if (isset($this->error['expires'])) {
            $data['error_expires'] = $this->error['expires'];
        } else {
            $data['error_expires'] = '';
        }

        $data['breadcrumbs'] = array();

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_home'),
            'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_extension'),
            'href' => $this->url->link('extension/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true)
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('heading_title'),
            'href' => $this->url->link('extension/payment/easypay', 'user_token=' . $this->session->data['user_token'], true)
        );

        if (isset($this->request->post['payment_easypay_merchant'])) {
            $data['payment_easypay_merchant'] = $this->request->post['payment_easypay_merchant'];
        } else {
            $data['payment_easypay_merchant'] = $this->config->get('payment_easypay_merchant');
        }

        if (isset($this->request->post['payment_easypay_webkey'])) {
            $data['payment_easypay_webkey'] = $this->request->post['payment_easypay_webkey'];
        } else {
            $data['payment_easypay_webkey'] = $this->config->get('payment_easypay_webkey');
        }

        if (isset($this->request->post['payment_easypay_expires'])) {
            $data['payment_easypay_expires'] = $this->request->post['payment_easypay_expires'];
        } elseif ($this->config->has('payment_easypay_expires')) {
            $data['payment_easypay_expires'] = $this->config->get('payment_easypay_expires');
        } else {
            $data['payment_easypay_expires'] = '2';
        }

        if (isset($this->request->post['payment_easypay_debug'])) {
            $data['payment_easypay_debug'] = $this->request->post['payment_easypay_debug'];
        } else {
            $data['payment_easypay_debug'] = $this->config->get('payment_easypay_debug');
        }

        if (isset($this->request->post['payment_easypay_sort_order'])) {
            $data['payment_easypay_sort_order'] = $this->request->post['payment_easypay_sort_order'];
        } else {
            $data['payment_easypay_sort_order'] = $this->config->get('payment_easypay_sort_order');
        }

        if (isset($this->request->post['payment_easypay_status'])) {
            $data['payment_easypay_status'] = $this->request->post['payment_easypay_status'];
        } else {
            $data['payment_easypay_status'] = $this->config->get('payment_easypay_status');
        }

        if (isset($this->request->post['payment_easypay_order_status_id'])) {
            $data['payment_easypay_order_status_id'] = $this->request->post['payment_easypay_order_status_id'];
        } elseif ($this->config->has('payment_easypay_order_status_id')) {
            $data['payment_easypay_order_status_id'] = $this->config->get('payment_easypay_order_status_id');
        } else {
            $data['payment_easypay_order_status_id'] = '1';
        }

        $this->load->model('localisation/order_status');
        $data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();

        if (isset($this->request->post['payment_easypay_processing_status_id'])) {
            $data['payment_easypay_processing_status_id'] = $this->request->post['payment_easypay_processing_status_id'];
        } elseif ($this->config->has('payment_easypay_processing_status_id')) {
            $data['payment_easypay_processing_status_id'] = $this->config->get('payment_easypay_processing_status_id');
        } else {
            $data['payment_easypay_processing_status_id'] = '5';
        }

        if (isset($this->request->post['payment_easypay_canceled_status_id'])) {
            $data['payment_easypay_canceled_status_id'] = $this->request->post['payment_easypay_canceled_status_id'];
        } elseif ($this->config->has('payment_easypay_canceled_status_id')) {
            $data['payment_easypay_canceled_status_id'] = $this->config->get('payment_easypay_canceled_status_id');
        } else {
            $data['payment_easypay_canceled_status_id'] = '10';
        }

        $data['header'] = $this->load->controller('common/header');
        $data['column_left'] = $this->load->controller('common/column_left');
        $data['footer'] = $this->load->controller('common/footer');

        $this->response->setOutput($this->load->view('extension/payment/easypay', $data));
    }

    protected function validate()
    {
        if (!$this->user->hasPermission('modify', 'extension/payment/easypay')) {
            $this->error['warning'] = $this->language->get('error_permission');
        }

        if (!$this->request->post['payment_easypay_webkey']) {
            $this->error['webkey'] = $this->language->get('error_webkey');
        }

        if (!$this->request->post['payment_easypay_merchant']) {
            $this->error['merchant'] = $this->language->get('error_merchant');
        }

        if (!$this->request->post['payment_easypay_expires']) {
            $this->error['expires'] = $this->language->get('error_expires');
        }

        return !$this->error;
    }
}